package net.lecnam.info.ex3;

import java.io.IOException;
import java.io.InputStream;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;
import java.io.OutputStream;
import java.net.Socket;
import java.net.UnknownHostException;
import net.lecnam.info.channel.ObjectReader;
import net.lecnam.info.channel.ObjectWriter;
import net.lecnam.info.channel.RemoteObjectReader;
import net.lecnam.info.channel.RemoteObjectWriter;

public class ClientMain {

	public static void main(String[] args) throws UnknownHostException, IOException {
		System.out.println("Running...");
		Socket s = new Socket("localhost", 55000);
		System.out.println("Connected to server.");
		System.out.println("Remote IP: " + s.getInetAddress());
		System.out.println("Local IP: " + s.getLocalAddress());
		System.out.println("Remote port: " + s.getPort());
		System.out.println("Local port: " + s.getLocalPort());

		InputStream is = s.getInputStream();
		OutputStream os = s.getOutputStream();

		ObjectOutputStream out = new ObjectOutputStream(os);
		ObjectInputStream in = new ObjectInputStream(is);

		ObjectWriter<Task<Integer>> owc = new RemoteObjectWriter<>(out);
		ObjectReader<Integer> orc = new RemoteObjectReader<>(in);

		Client client = new Client(orc, owc);
		client.run();

		s.close();
	}

}
