package net.lecnam.info.ex3;

import java.io.IOException;
import net.lecnam.info.channel.ObjectReader;
import net.lecnam.info.channel.ObjectWriter;

public class RemoteComputeEngine<T> {

	ObjectReader<T> in; 
	ObjectWriter<Task<T>> out;

	RemoteComputeEngine(ObjectReader<T> in, ObjectWriter<Task<T>> out) {
		this.in = in;
		this.out = out;
	}
	
	public void stop() throws IOException {
		Task<T> task = new Stop<>();
		out.writeObject(task);
		out.writeObject(task);
	}

	public T executeTask(Task<T> task) throws IOException {
		out.writeObject(task);
		T result = in.readObject();
		return result;
	}

	public Pair<T,T> executeTasks(Task<T> t1, Task<T> t2) throws IOException {
		out.writeObject(t1);
		out.writeObject(t2);
		T result1 = in.readObject();
		T result2 = in.readObject();
		return new Pair<>(result1, result2);
	}
	
}
