package net.lecnam.info.ex5;

import java.io.IOException;
import java.util.List;
import java.util.logging.Level;
import java.util.logging.Logger;
import net.lecnam.info.channel.ObjectReader;
import net.lecnam.info.channel.ObjectWriter;

public class Client implements Runnable {

	RemoteComputeEngine<Integer> rce; 

	Client(ObjectReader<List<Integer>> in, ObjectWriter<List<Task<Integer>>> out) {
		this.rce = new RemoteComputeEngine<>(in, out);
	}

	@Override
	public void run() {
		try {
			Task<Integer> task = new SimpleTask(4, 7);
			Task<Integer> task2 = new SimpleTask(9, 8);
			List<Task<Integer>> tasks = List.of(task, task2);
			List<Integer> results = rce.executeTasks(tasks);
			System.out.println(results);
			rce.stop();
		} catch (IOException ex) {
			throw new Error(ex);
		}
	}

}
