package net.lecnam.info.ex5;

import java.io.IOException;
import java.util.List;
import java.util.concurrent.BlockingQueue;
import java.util.concurrent.LinkedBlockingQueue;

import net.lecnam.info.channel.LocalObjectReader;
import net.lecnam.info.channel.LocalObjectWriter;
import net.lecnam.info.channel.ObjectReader;
import net.lecnam.info.channel.ObjectWriter;

public class Main {

	public static void main(String[] args) throws IOException {

	    BlockingQueue<List<Task<Integer>>> bqcs = new LinkedBlockingQueue<>();
	    BlockingQueue<List<Integer>> bqsc = new LinkedBlockingQueue<>();

		ObjectWriter<List<Integer>> ows = new LocalObjectWriter<>(bqsc);
		ObjectReader<List<Task<Integer>>> ors = new LocalObjectReader<>(bqcs);

		ComputeEngine<Integer> server = new ComputeEngine<>(ors, ows);

		ObjectWriter<List<Task<Integer>>> owc = new LocalObjectWriter<>(bqcs);
		ObjectReader<List<Integer>> orc = new LocalObjectReader<>(bqsc);

		Client client = new Client(orc, owc);

	    Thread tc = new Thread(client);
	    Thread ts = new Thread(server);

	    tc.start();
	    ts.start();

	}

}
