package net.lecnam.info.ex5;

import java.io.IOException;
import java.util.List;
import net.lecnam.info.channel.ObjectReader;
import net.lecnam.info.channel.ObjectWriter;

public class RemoteComputeEngine<T> {

	ObjectReader<List<T>> in; 
	ObjectWriter<List<Task<T>>> out;

	RemoteComputeEngine(ObjectReader<List<T>> in, ObjectWriter<List<Task<T>>> out) {
		this.in = in;
		this.out = out;
	}
	
	public void stop() throws IOException {
		List<Task<T>> empty = List.of();
		out.writeObject(empty);
	}

	public List<T> executeTasks(List<Task<T>> tasks) throws IOException {
		out.writeObject(tasks);
		List<T> result = in.readObject();
		return result;
	}
	
}
